/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifndef O2SCL_DERIV_IOC_H
#define O2SCL_DERIV_IOC_H
#include <string>
#include <o2scl/base_ioc.h>
#include <o2scl/eqi_deriv.h>
#include <o2scl/cern_deriv.h>
#include <o2scl/gsl_deriv.h>

#ifndef DOXYGENP
namespace o2scl {
#endif

  /** \brief Setup I/O objects for numerical differentiation classes
  */
  class deriv_ioc {
    
  public:
    
    deriv_ioc() {
      deriv_io=new deriv_io_type("deriv_io");
      eqi_deriv_io=new eqi_deriv_io_type("eqi_deriv_io");
      cern_deriv_io=new cern_deriv_io_type("cern_deriv_io");
      gsl_deriv_io=new gsl_deriv_io_type("gsl_deriv_io");
    }

    ~deriv_ioc() {
      delete deriv_io;
      delete eqi_deriv_io;
      delete cern_deriv_io;
      delete gsl_deriv_io;
    }

    deriv_io_type *deriv_io;
    eqi_deriv_io_type *eqi_deriv_io;
    cern_deriv_io_type *cern_deriv_io;
    gsl_deriv_io_type *gsl_deriv_io;
    
  protected:
    
#ifndef DOXYGENP
    
    base_ioc b;

#endif
  
  };

#ifndef DOXYGENP
}
#endif

#endif
