/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/multi_funct.h>
#include <o2scl/gsl_mmin_conp.h>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

double minfun(size_t n, const ovector_view &x, void *&pa) {
  double ret;
  ret=x[0]*x[0]+(x[1]-2.0)*(x[1]-2.0)+3.0;
  return(ret);
}

int minfun2(size_t n, const double x[2], double &y, void *&pa) {
  y=x[0]*x[0]+(x[1]-2.0)*(x[1]-2.0)+3.0;
  return 0;
}

int main(void) {
  test_mgr t;
  t.set_output_level(2);
  double min;
  ovector x(2);
  double x2[2];
  void *vp=0;
  gsl_mmin_conp<void *> g;
  //gsl_mmin_conp<void *,multi_vfunct<void *,2>,
  //double[2],double[2],array_alloc<double[2]>,multi_vfunct<void *,2> > g2;

  cout.setf(ios::scientific);

  multi_funct_fptr_noerr<void *> mf(minfun);
  multi_vfunct_fptr<void *,2> mf2(minfun2);
  
  x[0]=1.0;
  x[1]=1.0;
  int ret=g.mmin(2,x,min,vp,mf);
  cout << min << " " << x[0] << " " << x[1] << endl;
  t.test_abs(x[0],0.0,1.0e-4,"gsl_mmin_conp 1");
  t.test_rel(x[1],2.0,2.0e-4,"gsl_mmin_conp 2");

  /*
    x2[0]=1.0;
    x2[1]=1.0;
    ret=g2.mmin(2,x2,min,vp,mf2);
    cout << min << " " << x2[0] << " " << x2[1] << endl;
    t.test_abs(x2[0],0.0,1.0e-4,"gsl_mmin_conp 1");
    t.test_rel(x2[1],2.0,2.0e-4,"gsl_mmin_conp 2");
  */

  t.report();
  return 0;
}
 
