/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/timer.h>
#include <iostream>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

int main(void) {
  timer_gettod n;
  n.reset();
  int d, h, m, s, f;
  test_mgr t;
  t.set_output_level(2);

  for(int i=0;i<400;i++) {
    for(double x=1.0e50;x>=1.0e-10;x=x/1.01);
    if (i%10==0) {
      n.set(); 
      cout << n.seconds_elapsed() << endl;
      n.time_elapsed(d,h,m,s,f);
      cout << d << " " << h << " " << m << " " << s << " " << f << endl;
    }
  }

  n.time_remaining(1,10,d,h,m,s,f);
  cout << d << " " << h << " " << m << " " << s << " " << f << endl;
  cout << n.interval_to_string(d,h,m,s,f) << endl;

  double x=100.0, ff;
  timer_clock at;
  string c;
  for(int i=0;i<10000;i++) {
    for(int j=0;j<1000;j++) {
      x=exp(sqrt(x));
    }
  }

  at.time_remaining(3,5,d,h,m,s,ff);
  c=at.interval_to_string(d,h,m,s,ff);
  cout << c << endl;
  ff=0.0;
  c=at.interval_to_string(d,h,m,s,ff);
  cout << c << endl;
  t.test_gen(d>=0,"days>0");
  t.test_gen(h>=0,"hours>0");
  t.test_gen(m>=0,"minutes>0");
  t.test_gen(s>=0,"seconds>0");
  t.test_gen(ff>=0.0,"fraction>0");
  t.report();
      
  t.report();
  return 0;
}

