/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/

#include <o2scl/boson.h>

using namespace std;
using namespace o2scl;
using namespace o2scl_const;

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  boson_io_type boson_io;
  part_io_type part_io;
  thermo_io_type thermo_io;

  void *vp;
  boson bo(1.0,1.0);
  t.test_rel(bo.m,1.0,1.0e-6,"mass inheritance");
  bo.co=7.0;
  boson *bo2;
  collection co;
  co.test_type(t,"boson",&bo,vp);
  bo2=(boson *)vp;
  t.test_rel(bo2->co,bo.co,1.0e-14,"input(output())");
  
  bo.massless_calc_mu(0.1);
  t.test_rel(bo.ed+bo.pr-bo.en*0.1,0.0,1.0e-8,"therm. ident.");
  
  t.report();
  return 0;
}
