/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <o2scl/deriv_part.h>

using namespace std;
using namespace o2scl;

//--------------------------------------------
// deriv_part class

deriv_part::deriv_part() {
  dndmu=0.0;
  dndT=0.0;
  dsdT=0.0;
  dndm=0.0;
}

template<> int io_tlate<deriv_part>::input(cinput *co, in_file_format *ins, 
					      deriv_part *f) {
  ins->double_in(f->dndmu);
  ins->double_in(f->dndT);
  ins->double_in(f->dsdT);
  ins->double_in(f->dndm);
  return 0;
}

template<> int io_tlate<deriv_part>::output(coutput *co, 
					    out_file_format *outs, 
					    deriv_part *f) {
  outs->double_out(f->dndmu);
  outs->double_out(f->dndT);
  outs->double_out(f->dsdT);
  outs->double_out(f->dndm);
  return 0;
}

template<> const char *io_tlate<deriv_part>::type() {
  return "deriv_part";
}

