(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     16214,        504]*)
(*NotebookOutlinePosition[     17063,        532]*)
(*  CellTagsIndexPosition[     17019,        528]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(Off[General::"\<spell\>"]; Off[General::"\<spell1\>"];\)], "Input"],

Cell[CellGroupData[{

Cell["The Hamiltonian", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(h2mns = \(1/2\)/M + n/4 \((t1 \((1 + x1/2)\) + t2 \((1 + x2/2)\))\) + 
        nn/4 \((t2 \((1/2 + x2)\) - t1 \((1/2 + x1)\))\)\)], "Input"],

Cell[BoxData[
    \(1\/\(2\ M\) + 
      1\/4\ n\ \((t1\ \((1 + x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
      1\/4\ nn\ \((\(-t1\)\ \((1\/2 + x1)\) + 
            t2\ \((1\/2 + x2)\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h2mps = \(1/2\)/M + n/4 \((t1 \((1 + x1/2)\) + t2 \((1 + x2/2)\))\) + 
        np/4 \((t2 \((1/2 + x2)\) - t1 \((1/2 + x1)\))\)\)], "Input"],

Cell[BoxData[
    \(1\/\(2\ M\) + 
      1\/4\ n\ \((t1\ \((1 + x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
      1\/4\ np\ \((\(-t1\)\ \((1\/2 + x1)\) + 
            t2\ \((1\/2 + x2)\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(kfn = \((3\ \(\[Pi]\^2\) nn)\)\^\(1/3\)\)], "Input"],

Cell[BoxData[
    \(3\^\(1/3\)\ nn\^\(1/3\)\ \[Pi]\^\(2/3\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(kfp = \((3\ \(\[Pi]\^2\) np)\)\^\(1/3\)\)], "Input"],

Cell[BoxData[
    \(3\^\(1/3\)\ np\^\(1/3\)\ \[Pi]\^\(2/3\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Tau]n = \(kfn\^5/5\)/\[Pi]\^2\)], "Input"],

Cell[BoxData[
    \(3\/5\ 3\^\(2/3\)\ nn\^\(5/3\)\ \[Pi]\^\(4/3\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Tau]p = \(kfp\^5/5\)/\[Pi]\^2\)], "Input"],

Cell[BoxData[
    \(3\/5\ 3\^\(2/3\)\ np\^\(5/3\)\ \[Pi]\^\(4/3\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hbulk = 
      Simplify[\[Tau]n\ h2mns + \[Tau]p\ h2mps + 
            t0/2 \((\((1 + x0/2)\) 
                    n\^2 - \((1/2 + x0)\) \((nn\^2 + np\^2)\))\) + 
            a\ t3/6 \((\((1 + x3/2)\)\ \(n\^\[Alpha]\) 
                    nn\ np + \(2\^\(\[Alpha] - 2\)\) \((1 - 
                        x3)\) \((nn\^\(\[Alpha] + 2\) + 
                        np\^\(\[Alpha] + 2\))\))\) + 
            b\ t3/12 \((\((1 + x3/2)\) 
                    n\^2 - \((1/2 + x3)\) \((nn\^2 + np\^2)\))\) n\^\[Alpha] /. 
          n \[Rule] nn + np]\)], "Input"],

Cell[BoxData[
    \(1\/120\ \((60\ t0\ \((\(-\((nn\^2 + np\^2)\)\)\ \((1\/2 + x0)\) + 
                1\/2\ \((nn + np)\)\^2\ \((2 + 
                      x0)\))\) - \(9\ 3\^\(2/3\)\ np\^\(5/3\)\ \[Pi]\^\(4/3\)\
\ \((\(-4\) - M\ \((np\ \((t1 - t1\ x1 + 3\ t2\ \((1 + x2)\))\) + nn\ \((t1\ \
\((2 + x1)\) + t2\ \((2 + x2)\))\))\))\)\)\/M - \(9\ 3\^\(2/3\)\ nn\^\(5/3\)\ \
\[Pi]\^\(4/3\)\ \((\(-4\) + M\ \((nn\ \((t1\ \((\(-1\) + x1)\) - 3\ t2\ \((1 \
+ x2)\))\) - np\ \((t1\ \((2 + x1)\) + t2\ \((2 + x2)\))\))\))\)\)\/M - 
          5\ b\ \((nn + np)\)\^\[Alpha]\ t3\ \((nn\^2\ \((\(-1\) + x3)\) + 
                np\^2\ \((\(-1\) + x3)\) - 2\ nn\ np\ \((2 + x3)\))\) + 
          5\ a\ t3\ \((\(-2\^\[Alpha]\)\ \((nn\^\(2 + \[Alpha]\) + 
                      np\^\(2 + \[Alpha]\))\)\ \((\(-1\) + x3)\) + 
                2\ nn\ np\ \((nn + np)\)\^\[Alpha]\ \((2 + 
                      x3)\))\))\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The energy of symmetric nuclear matter:", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hnuc = 
      Simplify[\(Hbulk /. nn \[Rule] n/2\) /. np \[Rule] n/2]\)], "Input"],

Cell[BoxData[
    \(\(n\^\(5/3\)\ \((10\ M\ \((6\ n\^\(1/3\)\ t0 + \((a + b)\)\ n\^\(1\/3 + \
\[Alpha]\)\ t3)\) + 3\ 2\^\(1/3\)\ 3\^\(2/3\)\ \[Pi]\^\(4/3\)\ \((8 + M\ n\ \
\((3\ t1 + 5\ t2 + 4\ t2\ x2)\))\))\)\)\/\(160\ M\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(kr23 = \(3/10\)/
          M \((3/2\ \(\[Pi]\^2\) n)\)\^\(2/3\)\), "\[IndentingNewLine]", 
    \(\[Beta] = M/2 \((1/4 \((3  t1 + 5  t2)\) + t2\ x2)\)\)}], "Input"],

Cell[BoxData[
    \(\(3\ \((3\/2)\)\^\(2/3\)\ n\^\(2/3\)\ \[Pi]\^\(4/3\)\)\/\(10\ M\)\)], \
"Output"],

Cell[BoxData[
    \(1\/2\ M\ \((1\/4\ \((3\ t1 + 5\ t2)\) + t2\ x2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hnuc2 = 
      n \((kr23 \((1 + \[Beta]\ n)\) + 
            3\ t0\ n/8\  + \ \((a + b)\) 
              t3\ n\^\(1 + \[Alpha]\)/16)\)\)], "Input"],

Cell[BoxData[
    \(n\ \((\(3\ n\ t0\)\/8 + 
          1\/16\ \((a + 
                b)\)\ n\^\(1 + \[Alpha]\)\ t3 + \(3\ \((3\/2)\)\^\(2/3\)\ n\^\
\(2/3\)\ \[Pi]\^\(4/3\)\ \((1 + 1\/2\ M\ n\ \((1\/4\ \((3\ t1 + 5\ t2)\) + t2\
\ x2)\))\)\)\/\(10\ M\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[Hnuc2 - Hnuc]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The effective masses in symmetric nuclear matter:", "Subsubsection"],

Cell["The inverse of the reduced effective mass:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MoMs = 
      Simplify[2\ M\ \((\(h2mns /. nn \[Rule] n/2\) /. 
              np \[Rule] n/2)\)]\)], "Input"],

Cell[BoxData[
    \(1\/8\ \((8 + M\ n\ \((3\ t1 + t2\ \((5 + 4\ x2)\))\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MoMs2 = 1 + \[Beta]\ n\)], "Input"],

Cell[BoxData[
    \(1 + 1\/2\ M\ n\ \((1\/4\ \((3\ t1 + 5\ t2)\) + t2\ x2)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[MoMs - MoMs2]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The incompressiblity of nuclear matter:", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(K = 
      Simplify[9 \( n\^2\) 
          D[D[\((\(Hbulk /. nn \[Rule] n/2\) /. np \[Rule] n/2)\)/n, n], 
            n]]\)], "Input"],

Cell[BoxData[
    \(\(3\ n\^\(2/3\)\ \((2\^\(1/3\)\ 3\^\(2/3\)\ \[Pi]\^\(4/3\)\ \((\(-8\) + \
5\ M\ n\ \((3\ t1 + t2\ \((5 + 4\ x2)\))\))\) + 15\ \((a + b)\)\ M\ n\^\(1\/3 \
+ \[Alpha]\)\ t3\ \[Alpha]\ \((1 + \[Alpha])\))\)\)\/\(80\ M\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(K2 = \(-2\) kr23 + 10  kr23\ \[Beta]\ n + 
        9/16\ \[Alpha] \((\[Alpha] + 1)\) \((a + b)\) 
          t3\ n\^\(1 + \[Alpha]\)\)], "Input"],

Cell[BoxData[
    \(\(-\(\(3\ \((3\/2)\)\^\(2/3\)\ n\^\(2/3\)\ \[Pi]\^\(4/3\)\)\/\(5\ M\)\)\
\) + 3\/2\ \((3\/2)\)\^\(2/3\)\ n\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((1\/4\ \((3\ t1 \
+ 5\ t2)\) + t2\ x2)\) + 
      9\/16\ \((a + 
            b)\)\ n\^\(1 + \[Alpha]\)\ t3\ \[Alpha]\ \((1 + \[Alpha])\)\)], \
"Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Simplify", "[", 
      RowBox[{
        RowBox[{Cell[""], "K2"}], "-", "K"}], "]"}]], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The symmetry energy:", "Subsubsection"],

Cell["Neutron matter:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Solve[{\((nn - np)\) == n\ \[Delta], n == nn + np}, {nn, 
        np}]\)], "Input"],

Cell[BoxData[
    \({{nn \[Rule] \(-\(1\/2\)\)\ \((\(-n\) - n\ \[Delta])\), 
        np \[Rule] \(-\(1\/2\)\)\ \((\(-n\) + n\ \[Delta])\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Esym = 
      Simplify[\((\(D[
                  D[\((\(Hbulk /. nn \[Rule] 1/2\ \((n + n\ \[Delta])\)\) /. 
                        np \[Rule] 
                          1/2\ \((n - n\ \[Delta])\))\), \[Delta]], \[Delta]]/
                2\)/n)\) /. \[Delta] \[Rule] 0]\)], "Input"],

Cell[BoxData[
    \(\(\(1\/\(96\ M\)\)\((8\ 2\^\(1/3\)\ 3\^\(2/3\)\ n\^\(2/3\)\ \
\[Pi]\^\(4/3\) - 12\ M\ n\ t0\ \((1 + 2\ x0)\) + 
        2\ 2\^\(1/3\)\ 3\^\(2/3\)\ M\ n\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((\(-3\)\ \
t1\ x1 + t2\ \((4 + 5\ x2)\))\) - 
        M\ n\^\(1 + \[Alpha]\)\ t3\ \((2\ b\ \((1 + 2\ x3)\) + 
              a\ \((2 - 3\ \[Alpha] - \[Alpha]\^2 + 
                    x3\ \((4 + 
                          3\ \[Alpha] + \[Alpha]\^2)\))\))\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Esym2 = 
      5/9  kr23 + 
        10/3\ M\ kr23\ n\ \((1/6\ t2\ \((1 + 5/4  x2)\) - 1/8  t1\ x1)\) - 
        1/24  b\ t3 \((1/2 + x3)\) n\^\(1 + \[Alpha]\) - 
        1/4\ t0\ \((1/2 + x0)\) n - 
        1\/96\ a\ n\^\(1 + \[Alpha]\)\ t3\ \((2 - \[Alpha]\ \((3 + \
\[Alpha])\) + x3\ \((4 + \[Alpha]\ \((3 + \[Alpha])\))\))\)\)], "Input"],

Cell[BoxData[
    \(\(n\^\(2/3\)\ \[Pi]\^\(4/3\)\)\/\(2\ 2\^\(2/3\)\ 3\^\(1/3\)\ M\) - 
      1\/4\ n\ t0\ \((1\/2 + 
            x0)\) + \((3\/2)\)\^\(2/3\)\ n\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((\(-\(\
\(t1\ x1\)\/8\)\) + 1\/6\ t2\ \((1 + \(5\ x2\)\/4)\))\) - 
      1\/24\ b\ n\^\(1 + \[Alpha]\)\ t3\ \((1\/2 + x3)\) - 
      1\/96\ a\ n\^\(1 + \[Alpha]\)\ t3\ \((2 - \[Alpha]\ \((3 + \[Alpha])\) \
+ x3\ \((4 + \[Alpha]\ \((3 + \[Alpha])\))\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[Esym - Esym2]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(EPaul = 
      5/9\ kr23\ \((1 + 
              6\ M\ n \((1/6  t2 \((1 + 5/4\ x2)\) - t1\ x1/8)\))\) - 
        t0/4 \((1/2 + x0)\)\ n + 
        a\ t3/24\ \(n\^\(1 + \[Alpha]\)\) \((\(-1\) - x3/2 + 
              1/4 \((1 - x3)\) \((\[Alpha] + 2)\) \((\[Alpha] + 1)\))\) - 
        b\ t3/24 \((1/2 + x3)\) n\^\(1 + \[Alpha]\)\)], "Input"],

Cell[BoxData[
    \(\(-\(1\/4\)\)\ n\ t0\ \((1\/2 + 
            x0)\) + \(n\^\(2/3\)\ \[Pi]\^\(4/3\)\ \((1 + 6\ M\ n\ \
\((\(-\(\(t1\ x1\)\/8\)\) + 1\/6\ t2\ \((1 + \(5\ x2\)\/4)\))\))\)\)\/\(2\ \
2\^\(2/3\)\ 3\^\(1/3\)\ M\) - 
      1\/24\ b\ n\^\(1 + \[Alpha]\)\ t3\ \((1\/2 + x3)\) + 
      1\/24\ a\ n\^\(1 + \[Alpha]\)\ t3\ \((\(-1\) - x3\/2 + 
            1\/4\ \((1 - 
                  x3)\)\ \((1 + \[Alpha])\)\ \((2 + \[Alpha])\))\)\)], \
"Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[Esym - EPaul]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Re-express Hamiltonian as in code:", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(vars = {ham1 -> 
          t0/2 \((1 + x0/2)\), \[IndentingNewLine]ham2 -> \(-t0\)/
              2 \((1/2 + x0)\), \[IndentingNewLine]ham3 -> 
          a\ t3/6 \((1 + x3/2)\), \[IndentingNewLine]ham4 -> 
          a\ t3\ 2\^\(\[Alpha] - 2\)/6 \((1 - x3)\), \[IndentingNewLine]ham5 -> 
          b\ t3/12 \((1 + x3/2)\), \[IndentingNewLine]ham6 -> \(-b\)\ t3/
              12 \((1/2 + x3)\)}\)], "Input"],

Cell[BoxData[
    \({ham1 \[Rule] 1\/2\ t0\ \((1 + x0\/2)\), 
      ham2 \[Rule] \(-\(1\/2\)\)\ t0\ \((1\/2 + x0)\), 
      ham3 \[Rule] 1\/6\ a\ t3\ \((1 + x3\/2)\), 
      ham4 \[Rule] 1\/3\ 2\^\(\(-3\) + \[Alpha]\)\ a\ t3\ \((1 - x3)\), 
      ham5 \[Rule] 1\/12\ b\ t3\ \((1 + x3\/2)\), 
      ham6 \[Rule] \(-\(1\/12\)\)\ b\ t3\ \((1\/2 + x3)\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Hcode = \[Tau]n\ h2mns + \[Tau]p\ h2mps + ham1\ n\^2 + 
        ham2 \((nn\^2 + np\^2)\) + ham3\ n\^\[Alpha]\ nn\ np + 
        ham4 \((nn\^\(\[Alpha] + 2\) + np\^\(\[Alpha] + 2\))\) + 
        ham5\ n\^\(2 + \[Alpha]\) + 
        ham6 \((nn\^2 + np\^2)\) n\^\[Alpha]\)], "Input"],

Cell[BoxData[
    \(ham1\ n\^2 + ham5\ n\^\(2 + \[Alpha]\) + ham3\ n\^\[Alpha]\ nn\ np + 
      ham2\ \((nn\^2 + np\^2)\) + ham6\ n\^\[Alpha]\ \((nn\^2 + np\^2)\) + 
      ham4\ \((nn\^\(2 + \[Alpha]\) + np\^\(2 + \[Alpha]\))\) + 
      3\/5\ 3\^\(2/3\)\ nn\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((1\/\(2\ M\) + 
            1\/4\ n\ \((t1\ \((1 + x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
            1\/4\ nn\ \((\(-t1\)\ \((1\/2 + x1)\) + 
                  t2\ \((1\/2 + x2)\))\))\) + 
      3\/5\ 3\^\(2/3\)\ np\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((1\/\(2\ M\) + 
            1\/4\ n\ \((t1\ \((1 + x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
            1\/4\ np\ \((\(-t1\)\ \((1\/2 + x1)\) + 
                  t2\ \((1\/2 + x2)\))\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[\((\(Hcode /. vars\) /. n \[Rule] nn + np)\) - 
        Hbulk]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(D[\((Hcode /. n \[Rule] nn + np)\), nn]\)], "Input"],

Cell[BoxData[
    \(2\ ham2\ nn + 2\ ham1\ \((nn + np)\) + 
      2\ ham6\ nn\ \((nn + np)\)\^\[Alpha] + 
      ham3\ np\ \((nn + np)\)\^\[Alpha] + 
      3\/20\ 3\^\(2/3\)\ np\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((t1\ \((1 + 
                  x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
      3\/5\ 3\^\(2/3\)\ nn\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((1\/4\ \((t1\ \((1 + 
                        x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
            1\/4\ \((\(-t1\)\ \((1\/2 + x1)\) + t2\ \((1\/2 + x2)\))\))\) + 
      3\^\(2/3\)\ nn\^\(2/3\)\ \[Pi]\^\(4/3\)\ \((1\/\(2\ M\) + 
            1\/4\ \((nn + np)\)\ \((t1\ \((1 + x1\/2)\) + 
                  t2\ \((1 + x2\/2)\))\) + 
            1\/4\ nn\ \((\(-t1\)\ \((1\/2 + x1)\) + 
                  t2\ \((1\/2 + x2)\))\))\) + 
      ham3\ nn\ np\ \((nn + np)\)\^\(\(-1\) + \[Alpha]\)\ \[Alpha] + 
      ham6\ \((nn + np)\)\^\(\(-1\) + \[Alpha]\)\ \((nn\^2 + 
            np\^2)\)\ \[Alpha] + 
      ham4\ nn\^\(1 + \[Alpha]\)\ \((2 + \[Alpha])\) + 
      ham5\ \((nn + np)\)\^\(1 + \[Alpha]\)\ \((2 + \[Alpha])\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(D[\((Hcode /. n \[Rule] nn + np)\), np]\)], "Input"],

Cell[BoxData[
    \(2\ ham2\ np + 2\ ham1\ \((nn + np)\) + 
      ham3\ nn\ \((nn + np)\)\^\[Alpha] + 
      2\ ham6\ np\ \((nn + np)\)\^\[Alpha] + 
      3\/20\ 3\^\(2/3\)\ nn\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((t1\ \((1 + 
                  x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
      3\/5\ 3\^\(2/3\)\ np\^\(5/3\)\ \[Pi]\^\(4/3\)\ \((1\/4\ \((t1\ \((1 + 
                        x1\/2)\) + t2\ \((1 + x2\/2)\))\) + 
            1\/4\ \((\(-t1\)\ \((1\/2 + x1)\) + t2\ \((1\/2 + x2)\))\))\) + 
      3\^\(2/3\)\ np\^\(2/3\)\ \[Pi]\^\(4/3\)\ \((1\/\(2\ M\) + 
            1\/4\ \((nn + np)\)\ \((t1\ \((1 + x1\/2)\) + 
                  t2\ \((1 + x2\/2)\))\) + 
            1\/4\ np\ \((\(-t1\)\ \((1\/2 + x1)\) + 
                  t2\ \((1\/2 + x2)\))\))\) + 
      ham3\ nn\ np\ \((nn + np)\)\^\(\(-1\) + \[Alpha]\)\ \[Alpha] + 
      ham6\ \((nn + np)\)\^\(\(-1\) + \[Alpha]\)\ \((nn\^2 + 
            np\^2)\)\ \[Alpha] + 
      ham4\ np\^\(1 + \[Alpha]\)\ \((2 + \[Alpha])\) + 
      ham5\ \((nn + np)\)\^\(1 + \[Alpha]\)\ \((2 + \[Alpha])\)\)], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1400}, {0, 1050}},
ScreenStyleEnvironment->"Presentation",
WindowSize->{1012, 734},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>"skyrme_eos.ps",
"Magnification"->1}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 87, 1, 37, "Input"],

Cell[CellGroupData[{
Cell[1866, 56, 40, 0, 56, "Subsubsection"],

Cell[CellGroupData[{
Cell[1931, 60, 160, 2, 37, "Input"],
Cell[2094, 64, 196, 4, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2327, 73, 160, 2, 37, "Input"],
Cell[2490, 77, 196, 4, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2723, 86, 72, 1, 45, "Input"],
Cell[2798, 89, 73, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2908, 95, 72, 1, 45, "Input"],
Cell[2983, 98, 73, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3093, 104, 64, 1, 43, "Input"],
Cell[3160, 107, 79, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3276, 113, 64, 1, 43, "Input"],
Cell[3343, 116, 79, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3459, 122, 573, 11, 123, "Input"],
Cell[4035, 135, 917, 13, 226, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5001, 154, 64, 0, 56, "Subsubsection"],

Cell[CellGroupData[{
Cell[5090, 158, 102, 2, 37, "Input"],
Cell[5195, 162, 237, 3, 79, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5469, 170, 184, 3, 67, "Input"],
Cell[5656, 175, 101, 2, 68, "Output"],
Cell[5760, 179, 83, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5880, 185, 167, 4, 44, "Input"],
Cell[6050, 191, 268, 5, 79, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6355, 201, 55, 1, 37, "Input"],
Cell[6413, 204, 35, 1, 36, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6497, 211, 74, 0, 56, "Subsubsection"],
Cell[6574, 213, 58, 0, 44, "Text"],

Cell[CellGroupData[{
Cell[6657, 217, 129, 3, 37, "Input"],
Cell[6789, 222, 89, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6915, 228, 55, 1, 37, "Input"],
Cell[6973, 231, 90, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7100, 237, 55, 1, 37, "Input"],
Cell[7158, 240, 35, 1, 36, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7242, 247, 64, 0, 56, "Subsubsection"],

Cell[CellGroupData[{
Cell[7331, 251, 155, 4, 44, "Input"],
Cell[7489, 257, 250, 3, 79, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7776, 265, 164, 3, 40, "Input"],
Cell[7943, 270, 307, 6, 68, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8287, 281, 121, 3, 44, "Input"],
Cell[8411, 286, 35, 1, 36, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8495, 293, 45, 0, 56, "Subsubsection"],
Cell[8543, 295, 31, 0, 44, "Text"],

Cell[CellGroupData[{
Cell[8599, 299, 103, 2, 37, "Input"],
Cell[8705, 303, 153, 2, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8895, 310, 304, 6, 37, "Input"],
Cell[9202, 318, 474, 8, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9713, 331, 360, 7, 90, "Input"],
Cell[10076, 340, 456, 7, 102, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10569, 352, 55, 1, 37, "Input"],
Cell[10627, 355, 35, 1, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10699, 361, 360, 7, 61, "Input"],
Cell[11062, 370, 459, 9, 110, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11558, 384, 55, 1, 37, "Input"],
Cell[11616, 387, 35, 1, 36, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11700, 394, 59, 0, 56, "Subsubsection"],

Cell[CellGroupData[{
Cell[11784, 398, 426, 7, 159, "Input"],
Cell[12213, 407, 364, 6, 97, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12614, 418, 300, 5, 73, "Input"],
Cell[12917, 425, 727, 11, 125, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13681, 441, 104, 2, 37, "Input"],
Cell[13788, 445, 35, 1, 36, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13860, 451, 72, 1, 37, "Input"],
Cell[13935, 454, 1055, 18, 211, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15027, 477, 72, 1, 37, "Input"],
Cell[15102, 480, 1055, 18, 211, "Output"]
}, Open  ]],
Cell[16172, 501, 26, 0, 37, "Input"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

